.686
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc

includelib kernel32.lib
includelib user32.lib

;include ..\Tool\Automation.inc
include \RadASM\Masm\Inc\radasm.inc


.const
;include ..\Tool\OleConstants.inc
;include ..\Tool\Constants.inc
;include ..\Tool\AboutDlgConst.inc

.data
include AddinInitData.inc
IDD_MAINDLG equ 0
;include ..\Tool\OleInitData.inc
;include ..\Tool\InitiatedData.inc
;include ..\Tool\AboutDlgData.inc

.data?
include AddinUninitData.inc
hInstance dd ?
;include ..\Tool\UninitiatedData.inc

.code

;include ..\Tool\AsmIncludes.inc

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov eax, hInst
	mov hInstance, eax
;	.if reason==DLL_PROCESS_ATTACH
;	.elseif reason==DLL_PROCESS_DETACH
;	.elseif reason==DLL_THREAD_ATTACH
;	.elseif reason==DLL_THREAD_DETACH
;	.endif
	mov eax, TRUE
	ret
DllEntry Endp

InstallDll proc uses ebx hWin:DWORD, fOpt:DWORD
	mov	ebx,hWin

	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHandles,eax

	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpData,eax
	
	;Pointer to project file, *.rap
	mov eax,lpData
	push [eax].ADDINDATA.lpProject
	pop pProjectFile

	; If Option (fOpt) = 0 then exit
	mov eax,fOpt
	mov fOption,eax
	test eax,eax
	je @exit
	
	;Get the Frame window handle
	mov ebx,[lpHandles]
	mov ebx,(ADDINHANDLES ptr [ebx]).hWnd

	; Allocate a new menu id
	invoke SendMessage,ebx,AIM_GETMENUID,0,0 ;Popup menu Automation in project's menu
	mov IDAddIn,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDReference,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDObjects,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDImpInt,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDDisp,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDEnum,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDInterfaces,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDImpLibs,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDTypedefs,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDUnions,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDStructures,eax
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDModules,eax
	
	call AddMenu

	; Messages to hook into
	mov	eax, RAM_COMMAND OR RAM_CLOSE ;OR RAM_MENUREBUILD OR RAM_TBRTOOLTIP \
;			OR RAM_PROJECTOPENED OR RAM_PROJECTCLOSE

@exit:
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
	ret 

InstallDll Endp

GetOptions proc
	mov eax,offset AddinOpt
	ret
GetOptions endp

DllProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
    ; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from processing Command

	mov	eax, uMsg
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
;		push eax
;		invoke GetThreadLocale
;		mov lcid,eax
;		pop eax
		.if edx == IDReference && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,0
		.elseif edx == IDObjects && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,1
		.elseif edx == IDImpLibs && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,3
		.elseif edx == IDImpInt && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,2
		.elseif edx == IDEnum && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,40
		.elseif edx == IDDisp && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,41
		.elseif edx == IDInterfaces && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,42
		.elseif edx == IDTypedefs && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,43
		.elseif edx == IDUnions && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,44
		.elseif edx == IDStructures && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,45
		.elseif edx == IDModules && eax == BN_CLICKED
			invoke DialogBoxParam,hInstance,IDD_MAINDLG,0,0,0 ;offset MainDlgProc,46
		.endif
		mov hTLB,eax
		mov eax,TRUE
		ret

	.elseif eax==AIM_CLOSE
		mov edx,lpHandles
		invoke DeleteMenu,[edx].ADDINHANDLES.hMenu,IDAddIn,MF_BYCOMMAND
		
		invoke SendMessage,hTLB,WM_CLOSE,0,0
		
;		mov edx,lpHandles
;		invoke SendMessage,[edx].ADDINHANDLES.hToolBar,TB_COMMANDTOINDEX,IDAddIn,0
;		mov edx,lpHandles
;		invoke SendMessage,[edx].ADDINHANDLES.hToolBar,TB_DELETEBUTTON,eax,0
		
	.elseif eax==AIM_MENUREBUILD
;		call AddMenu
		
	.elseif eax==AIM_TBRTOOLTIP
		mov	eax,wParam
		.if eax==IDAddIn
			mov eax,offset szAddinToolTip
			ret
		.endif
		
	.elseif eax==AIM_PROJECTCLOSE
;		invoke SendMessage,hTLB,WM_CLOSE,0,0
		
	.elseif eax==AIM_PROJECTOPENED
		;
	.endif

	mov eax,FALSE
	ret
	
DllProc Endp

AddMenu proc
	LOCAL nMnu:DWORD
	LOCAL hMnu:DWORD

	.if IDAddIn
		mov	nMnu,4
		
		;Adjust topmost popup if maximized
		mov	eax,[lpData]
		mov	eax,(ADDINDATA ptr [eax]).fMaximized
		.if eax
			inc	nMnu
		.endif

		;Get handle of menu
		mov	eax,[lpHandles]
		mov	eax,(ADDINHANDLES ptr [eax]).hMenu

		;Get handle of Tools popup
		invoke GetSubMenu,eax,nMnu		;Tools menu
		mov hMnu,eax
		
		invoke CreatePopupMenu
		mov hRefDlgMnu,eax
		
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDReference,offset szTabReference
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDObjects,offset szTabCoClasses
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDImpInt,offset szTabCoClassMethods
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDImpLibs,offset szTabImpLibs
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDEnum,offset szTabEnum
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDDisp,offset szTabDispInt
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDInterfaces,offset szTabInterface
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDTypedefs,offset szTabTypedefs
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDUnions,offset szTabUnions
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDStructures,offset szTabStructures
		invoke AppendMenu,hRefDlgMnu,MF_STRING,IDModules,offset szTabModules
		
		;Add our menuitem
		invoke AppendMenu,hMnu,MF_STRING or MF_POPUP,hRefDlgMnu,addr szAddin

    .endif
	ret
AddMenu endp

End DllEntry
